
/********************************** (C) COPYRIGHT *******************************
* File Name          : USBHostHUB_KM.C
* Author             : WCH
* Version            : V1.0
* Date               : 2017/01/20
* Description        :
 USB host example for CH554, CH554USB MIDI豸ԲCH345Ϊ
*******************************************************************************/

#include "..\..\Public\CH554.H"                                               
#include "..\..\Public\Debug.H"
#include "..\USB_LIB\USBHOST.H"
#include <stdio.h>
#include <string.h>

#pragma  NOAREGS

/*ȡ豸*/
UINT8C  SetupGetDevDescr[] = { USB_REQ_TYP_IN, USB_GET_DESCRIPTOR, 0x00, USB_DESCR_TYP_DEVICE, 0x00, 0x00, sizeof( USB_DEV_DESCR ), 0x00 };

/*ȡ*/
UINT8C  SetupGetCfgDescr[] = { USB_REQ_TYP_IN, USB_GET_DESCRIPTOR, 0x00, USB_DESCR_TYP_CONFIG, 0x00, 0x00, 0x04, 0x00 };

/*USBַ*/
UINT8C  SetupSetUsbAddr[] = { USB_REQ_TYP_OUT, USB_SET_ADDRESS, USB_DEVICE_ADDR, 0x00, 0x00, 0x00, 0x00, 0x00 };

/*USB*/
UINT8C  SetupSetUsbConfig[] = { USB_REQ_TYP_OUT, USB_SET_CONFIGURATION, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };

/*USBӿ*/
UINT8C  SetupSetUsbInterface[] = { USB_REQ_RECIP_INTERF, USB_SET_INTERFACE, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };

/*˵STALL*/
UINT8C  SetupClrEndpStall[] = { USB_REQ_TYP_OUT | USB_REQ_RECIP_ENDP, USB_CLEAR_FEATURE, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };

/*ȡHUB*/
UINT8C  SetupGetHubDescr[] = { HUB_GET_HUB_DESCRIPTOR, HUB_GET_DESCRIPTOR, 0x00, USB_DESCR_TYP_HUB, 0x00, 0x00, sizeof( USB_HUB_DESCR ), 0x00 };

/*ȡHID豸*/
UINT8C  SetupGetHIDDevReport[] = { 0x81, USB_GET_DESCRIPTOR, 0x00, USB_DESCR_TYP_REPORT, 0x00, 0x00, 0x41, 0x00 };

/*ӡ*/
UINT8C  XPrinterReport[] = { 0xA1, 0, 0x00, 0, 0x00, 0x00, 0xF1, 0x03 };

UINT8X  UsbDevEndp0Size;                                                       //* USB豸Ķ˵0ߴ */
UINT8X  RxBuffer[ MAX_PACKET_SIZE ] _at_ 0x0000 ;                              // IN, must even address
UINT8X  TxBuffer[ 256 ] _at_ 0x0040 ;                              // OUT, must even address

UINT8 Set_Port = 0;

_RootHubDev xdata ThisUsbDev;                                                   //ROOT
_DevOnHubPort xdata DevOnHubPort[HUB_MAX_PORTS];                                // ٶ:1ⲿHUB,ÿⲿHUBHUB_MAX_PORTS˿(˲)

bit     RootHubId;                                                              // ǰڲroot-hub˿ں:0=HUB0,1=HUB1
bit     FoundNewDev;

extern MIDI_INFO        Midi;

void main( )
{
    UINT8   i, s, len, endp;
    UINT16  loc;
    CfgFsys( );	
    mDelaymS(5);	                                                              //޸Ƶȴʱȶ
    mInitSTDIO( );                                                              //Ϊüͨڼʾ
    printf( "Start @ChipID=%02X\n", (UINT16)CHIP_ID );
    InitUSB_Host( );
    FoundNewDev = 0;
    printf( "Wait Device In\n" );
    while ( 1 )
    {
        s = ERR_SUCCESS;
        if ( UIF_DETECT ){                                                       // USBж
            UIF_DETECT = 0;                                                      // жϱ־
            s = AnalyzeRootHub( );                                               // ROOT-HUB״̬
            if ( s == ERR_USB_CONNECT ) FoundNewDev = 1;						
        }
        if ( FoundNewDev ){                                                      // µUSB豸
            FoundNewDev = 0;
            mDelaymS( 200 );                                                     // USB豸ղδȶ,ʵȴUSB豸ٺ,ζ
            s = EnumAllRootDevice( );                                            // öROOT-HUB˿ڵUSB豸
            if ( s != ERR_SUCCESS ){
                printf( "EnumAllRootDev err = %02X\n", (UINT16)s );
            }
        }
		
		if(ThisUsbDev.DeviceStatus == ROOT_DEV_SUCCESS)
		{
			if(Midi.AudioType==0x03)  
			{
				SelectHubPort( 0 ); 
				
				if( Midi.BulkInEp!=0)    //IN
				{
					s = USBHostTransact( USB_PID_IN << 4 | Midi.BulkInEp & 0x7F, Midi.BulkInEp & 0x80 ? bUH_R_TOG | bUH_T_TOG : 0, 0 );// CH554,ȡ,NAK
					if ( s == ERR_SUCCESS ){
						Midi.BulkInEp ^= 0x80;                                             // ͬ־ת
						len = USB_RX_LEN;                                         // յݳ
						if ( len ) {
							printf("midi data: ");
							for ( i = 0; i < len; i ++ ){
								printf("x%02X ",(UINT16)(RxBuffer[i]) );
							}
							printf("\n");
						}
					}
					else if ( s != ( USB_PID_NAK | ERR_USB_TRANSFER ) ) {
						printf("midi error %02x\n",(UINT16)s);                   // ǶϿ
					}				
				}
				if( Midi.BulkOutEp!=0)  //OUT
				{
//					UH_TX_LEN = 64;
//					for ( i = 0; i != UH_TX_LEN; i ++ )
//					{
//						TxBuffer[ i ] = 0;  //0
//					}
//				
//					s = USBHostTransact( USB_PID_OUT << 4 | Midi.BulkOutEp & 0x7F, Midi.BulkOutEp & 0x80 ? bUH_R_TOG | bUH_T_TOG : 0, 0 );// CH554,ȡ,NAK
//					if ( s == ERR_SUCCESS ){
//						Midi.BulkOutEp ^= 0x80;                                             // ͬ־ת

//					}
				
				}

			}				
			
			
		}

    }
}



